
function p=SDC(signal,N,d,P,k)

%functions to compute shifted delta cepstral coefficients from MFCC and PLP
%
%Signal is coeff of MFCC or PLP
%Returns coloums of SDCs. if k=7, there are 7 coloums for each MFCC

%Author Tommy Strmhaug, 2008


%d and P considered in frames. N amd k is ints
%N=7;  % number of c cepstral coefficients in each cepstral vector
%d=1;  % time advance and delay for the delta computation
%P=3;  % timeshift netween consecutive blocks
%k=7;  % number of blocks whose delta coefficients are concatenated to form the SDC vector

%dimension of signal
[row,col]=size(signal);

%init variables
sdc=[];
sdc_temp=[];

%Pad data to not get out of bound. circular padding
right=signal(:,col-9:col);
left =signal(:,1:21);
signal=cat(2,signal,left);
signal=cat(2,right,signal);

%time watch
tic

for t=11:col+10
    for i=0:k-1

        sdc_temp=signal(:,t+i*P+d)-signal(:,t+i*P-d);
        sdc=cat(2,sdc,sdc_temp);

    end

end
toc
p=sdc;
