function mini=cdp(ref, stream);

% Continuous DP algorithm for spotting reference frames in a stream
% See article : Spotting Method for Classification of Real World Data, by Ryuichi Oka

% Author Tommy Strmhaug, 2008

clear P;

%init variables
tau=1;
mini=inf;
P=zeros(numel(ref),4);

%According to algorith these must be inf.
P(:,1)=inf;
P(:,2)=inf;

tic
for t2=3:numel(stream),
    t=t2;
    if t2>4
       t=4;
       P(:,1)=[];
    end
    
    while(tau<numel(ref)+1)
        if (tau==1)
            P(1,t)=3*abs(stream(t2)-ref(1));
        end
        
        if (tau==2)
            
            temp=min(P(1,t-2)+2*abs(stream(t2-1)-ref(2))+abs(stream(t2)-ref(2)),P(1,t-1)+3*abs(stream(t2)-ref(2)));
            P(2,t)= min(temp,P(1,t)+3*abs(stream(t2)-ref(2))); 
            
        end
               
        if(tau>2)
            
            temp=min(P(tau-1,t-2)+2*abs(stream(t2-1)-ref(tau))+abs(stream(t2)-ref(tau)),P(tau-1,t-1)+3*abs(stream(t2)-ref(tau)));
            P(tau,t)= min(temp,P(tau-2,t-1)+3*abs(stream(t2)-ref(tau-1))+3*abs(stream(t2)-ref(tau))); 
                    
        end
    tau=tau+1;
    end
   
    if(P(tau-1,t)/(3*(tau-1))<mini)
        mini=P(tau-1,t)/(3*(tau-1));
    end

    p(t2)=P(tau-1,t)/(3*(tau-1));
    
    tau=1;
        
end

%At last plot the contour of spotting
plot(p)


toc
