
function []=extract_words()

%Function to split a file into words according to the trascription file

%Read all transcription files and wavefiles from each dialect directory and
%split files into word accordingly to trascription files
%Change variables manually for other files, like name, and number of lines
%in the .WRD file

%Author Tommy Strmhaug,2008

%Change this for other catalogs(DR1-DR8)
dialect='DR8\'

%This has to be changed for each dialect
dir2 = ['E:\speech samples\TIMIT\TRAIN\' dialect];

%read all names in dir
a=dir(dir2)

%Iterate all catalogs in dir2 path
for i=3:length(a)
ext=a(i).name

%Define paths
path1=['E:\speech samples\TIMIT\TRAIN\' dialect ext '\' 'SA1.wav']
path2=['E:\speech samples\TIMIT\TRAIN\' dialect ext '\' 'SA2.wav']
path3=['E:\speech samples\TIMIT\TRAIN\' dialect ext '\' 'SA1.WRD']
path4=['E:\speech samples\TIMIT\TRAIN\' dialect ext '\' 'SA2.WRD']

[wfile1,sr] = wavread(path1);
[wfile2,sr] = wavread(path2);

%obtain beginning and end of each word 
[s1, e1, wrd1] = textread(path3,'%f %f %s', 11);
[s2, e2, wrd2] = textread(path4,'%f %f %s', 10);

%split file into words and save with same filename as word
for it=1:length(s1)
    
    b=['E:\speech samples\TIMIT\TRAIN\' dialect ext '\' 'SA1\' ]
    mkdir (b)
    name = strcat(b,wrd1{it},'.wav');
    
    temp=wfile1;
    newWord=temp(s1(it):e1(it));
    wavwrite(newWord,sr,name)
end

for it=1:length(s2)
    b=['E:\speech samples\TIMIT\TRAIN\' dialect ext '\' 'SA2\']
    mkdir (b)
    name = strcat(b,wrd2{it},'.wav');
    
    temp=wfile1;
    newWord=temp(s2(it):e2(it));
    wavwrite(newWord,sr,name)
end

end
