function []= feat_extract();

%Function to extract short time RMS and silence with application to speech/music discrimination
%Function takes no paramters and dont return anything, but it writes
%feature vectors to disk.

%Author Tommy Strmhaug, 2008

%location of train files
dname=('speech');

%Iterate over both speech and music files

for i=1:1
    tempX=0;
    if (i~=1)
        dname='music';
    end

    %catalog containing training files
    dir2 = ['C:\matlab\musicspeech\wavfile\train\' dirname '\'];

    %Store files and catalogs in a temp variable
    a=dir(dir2);

    %No overlap
    overlap =0;

    %Open file for writing and add 'svm' for not to confuse with feat-extract routines.

    fid = fopen([dirname 'svm' '.dat'],'w','a');
    %remover . and .. from file list
    for x=3:4

        filename=[dir2 a(x).name];
        %read in file on by one
        [signal,sr]=wavread(filename);

        %samples/millisecond
        sm = sr/1000;

        %20 millisecond window in samples
        windowlength = floor(sm*20);

        %total number of frames
        lengthFrames=floor(length(signal)/windowlength);

        %feature length in millisecond. This is a desicion window
        fl=2000;
        %feature length in frames. This is a desicion window
        featureLengthFrames=(sm*fl)/(sm*20);

        if overlap
            delta = windowlength/5;
        else
            delta = windowlength;
        end

        %Help variable
        index = 0;

        %make copy of original signal
        s=signal;

        %inital number of silence windows
        silenceFrames=0;
        nonSilenceFrames=0;

        %RMS calculation
        signal = signal.^2; % Square the samples
        for i = 1:delta:length(signal)-windowlength+1
            index = index+1;
            % Average and take the square root of each window
            temp(i) = sqrt(mean(signal(i:i+windowlength-1)));
            if (abs(temp(i))<0.0010)
                y(index)=0;
                s(i:i+windowlength)=0;
            else
                y(index)=temp(i);
            end
        end

        %subplot(3,1,1);
        %plot(s,'-r')

        %hold on;
        %subplot(3,1,2);
        %plot(temp)

        %number of desicion windows
        numberOfD = floor(lengthFrames/featureLengthFrames);

        %init
        highEnergyFrames=0;
        lowEnergyFrames=0;

        %Put each feature frame into an array
        totalVar=[];

        %Find silence frames
        for x1=1:numberOfD

            frames=y(1:featureLengthFrames);
            variance=var(frames);

            totalVar(end+1)=variance;
            average=mean(frames);
            for x2=1:length(frames)

                if (frames(x2)/average)<0.15
                    lowEnergyFrames=lowEnergyFrames+1;
                else
                    highEnergyFrames=highEnergyFrames+1;
                end

                if frames(x2)==0
                    silenceFrames=silenceFrames+1;
                else
                    nonSilenceFrames=nonSilenceFrames+1;
                end

            end
            %fprintf(fid,'%f,%s\n',lowEnergyFrames/(lowEnergyFrames+highEnergyFrames),'speech');
            %Write to file for use with WEKA
            fprintf(fid,'%f,%f,%f,%s\n',variance,silenceFrames/(silenceFrames+nonSilenceFrames),lowEnergyFrames/(lowEnergyFrames+highEnergyFrames),dirname);
            silenceFrames=0;
            nonSilenceFrames=0;
            highEnergyFrames=0;
            lowEnergyFrames=0;
            y(1:featureLengthFrames)=[];
            frames=[];
            variance=0;
            average=0;

        end
        %subplot(3,1,3);
        %plot(totalVar,'-rs')

    end

    %close file
    fclose(fid);

end
