
function [frames,Z, s,x]= feat_extract2();

%function to extract features and same to files : speech.dat and music.dat
%mfcc
%location of train files

error=0;

%Parameter adjusting, 1 means true, 0 false

%number of Melfcc coeff to extract
numCoeff=8;
%use melfcc(1) or not(0)
mel=1;

%remove power term
remove_power=0;

%delta
addDelta=0;
deltas=[];

%deltadelt
addDeltaDelta=0;
deltadeltas=[]

%SDC 
%Dont use delta or deltadelta or rmover power term with this option. However one can use mel +
%SDC. With this option N Melfcc are added to the SDC. remove power is done
%automatic with this option

N=7;  % number of cepstral coefficients in each cepstral vector
d=1;  % time advance and delay for the delta computation
P=3;  % timeshift netween consecutive blocks
k=7;  % number of blocks whose delta coefficients are concatenated to form the SDC vector

SDC_coeff=1;
SDC_c=[];

%variable to hold total coeff
totalCoeff=0;

features=[];

%name of directory for train files. This also become the filename of the
%model
dname=('speech');

%Iterate over both speech and music files
for i=3:3
tempX=0;
if (i==2)
    dname='music';
end

if(i==3)
    dname='othersounds2';
end
    

%Path to trainfiles music and speech
if (i==1 || i==2)
dir2 = ['d:\matlab\musicspeech\wavfile\train\' dname '\']
else
    dir2=['d:\matlab\' dname '\BBC train\']
end

%read all names in dir
a=dir(dir2);

%Open file for writing
fid = fopen([dname '.dat'],'w','a');
%index start at 3 to remover . and .. from file list
for x=3:length(a);
    
    sprintf('%s %2.0f','Processing trainfile :',x-2) 
    %filename of training file
    filename=[dir2 a(x).name];
    %read wave 
    [signal,sr]=wavread(filename);
    %check size, files are 22kHz and use only first 4 seconds if files are
    %bigger than 4 seconds
    length(signal);
    if (length(signal)>(88200))
        signal=signal(1:(88200));
    end
    length(signal);
    
        
    if(mel==1)
    coeff1=melfcc(signal,sr,'numcep', numCoeff);
    totalCoeff=numCoeff;
    end
      
   if(remove_power==1)
        %remove first coeffient
        coeff1(1,:)=[]; 
        totalCoeff=numCoeff-1;
   else 
        totalCoeff=numCoeff;    
   end
   

   
   if(SDC_coeff==1 && mel==1)
       coeff1=melfcc(signal,sr,'numcep', numCoeff);
       coeff1(1,:)=[]; 
       %make a copy of MFCCs
       coeff2=coeff1;
       totalCoeff=numCoeff-1;
       totalCoeff=(totalCoeff*k);
       SDC_c=SDC(coeff1,N,d,P,k);
       %to get correct length
       coeff1=SDC_c;
       
       %SDC_c(1:100)
   else
       
       if(SDC_coeff==1 && ~(mel==1))
       coeff1=melfcc(signal,sr,'numcep', numCoeff);
       coeff1(1,:)=[]; 
      
       totalCoeff=numCoeff-1;
       totalCoeff=totalCoeff*k;
       SDC_c=SDC(coeff1,N,d,P,k);
       %to get correct length
       coeff1=SDC_c;
       %SDC_c(1:100)
     end
   end
 
   
    if(addDelta)==1
        deltas = delta(coeff1);
    
    end
    
    if(addDeltaDelta)==1
    deltadeltas=deltadelta(deltas);
    
    end
     
    
    %samples/millisecond
    sm = sr/1000;
    %20 millisecond window in samples
    windowlength = floor(sm*20);

%total number of frames
lengthFrames=floor(length(signal)/windowlength);

%feature length in millisecond. This is a desicion window
fl=2000;
%feature length in frames. This is a desicion window
featureLengthFrames=(sm*fl)/(sm*20);

%Number of chunks of mfccs
%coeff1=coeff1(:);
[r,c]=size(coeff1);
r*c;
len=r*c;
totalCoeff;

%Check that MFCC length is legal, if not cut to right length.
if (mod(len,totalCoeff)~=0)
    error=error+1;
    
    re=floor(len/totalCoeff);
    len=re*totalCoeff;
end



coeff1;

%help variable
j=1;  
error
%make feature file
for i2=1:totalCoeff:len
    %Write flag
    writeFlag=1;
    
   
    
   if(mel && ~SDC_coeff)
         %check and discard NaN feature lines
       if (any(isnan(coeff1(i2:i2+totalCoeff-1))) || any(isnan(deltas(i2:i2+totalCoeff-1))) || any(isnan(deltadeltas(i2:i2+totalCoeff-1))));
           %Do not write to file
           writeFlag=-1;
       end
       features =[coeff1(i2:i2+totalCoeff-1)];
   

        if(addDelta==1)
            features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1)];    
        end
   
        if(addDeltaDelta==1)
               features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1) deltadeltas(i2:i2+totalCoeff-1)];
         end
   end


   
   
    
    if(SDC_coeff==1 && mel==1)
      
       %check and discard NaN feature lines
       if (any(isnan(coeff2(j:j+(numCoeff-1)-1))) || any(isnan(SDC_c(i2:i2+(totalCoeff)-1))))
           %Do not write to file
           writeFlag=-1;
       end

       features =[coeff2(j:j+(numCoeff-1)-1) SDC_c(i2:i2+(totalCoeff)-1) ];
     
    else
     if(SDC_coeff==1 && ~(mel==1))
            
         features =[SDC_c(i2:i2+(totalCoeff)-1)];
     end
    end
    
    j=j+7;
  
   
   
   if(writeFlag~=-1)
   fprintf(fid,'%f ',features,6);
   fprintf(fid,'\n');    
   end
end
   
    
end
    

end

fclose(fid);



