
function []= feat_extract3();

%Function to extract features for language identification and save to file
%This file is kind of messy because there are little internal control, so
%it is possible to run illegal combinations of parameters. Each parameter
%has a comment of the most important restrictions. An example is that one
%should not run PLP and MFCC at the same time. One also have to make sure
%that the parameters are equal for this function and the test function.

%Parameter adjusting are marked with boxes of %s, 1 means true, 0 false

%A variable to keep track of errors
error=0;

%delta parameter
di=0;

%%%%%%%%%%%
%PLP-Rasta%
%%%%%%%%%%%
%Do not use this together with MFCC. Do not use remove power either.
%When using PLP together with SDC ->order*k is the number of concatenated
%deltas to form the SDC.

PLP=1;
%Rasta filtering
rasta=1;
%model order. Remember that order+1 is number of coefficients
order=7;

%%%%%%
%MFCC%
%%%%%%
mel=0;
%Number of MFCC coeffs to extract. This is the number before removing the
%power term. Do not use together with PLP
numCoeff=8;

%%%%%%%%%%%%%%%%%%%
%Remove power term%
%%%%%%%%%%%%%%%%%%%
remove_power=0;

%%%%%%%%%%%%%%%%
%Remove Silence%
%%%%%%%%%%%%%%%%
remove_silence=1;

%%%%%%%%%%%%%%%%%
%Feature Warping%
%%%%%%%%%%%%%%%%%
featureWarp=0;
%time in seconds for feature warp window
time=3;
%Window length in number of features(default step time for MFCC is 10 ms)

if(mel==1)
    windowLength=numCoeff*time*100+1;
end

if(PLP==1)
    windowLength=(order+1)*time*100+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Cepstral Mean Substraction%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CMS=0;

%%%%%%%%%%%%%%%%%%%%
%Delta coefficients%
%%%%%%%%%%%%%%%%%%%%
addDelta=0;
deltas=[];

%%%%%%%%%%%%%%%%%%%%%%%%%%
%Delta delta coefficients%
%%%%%%%%%%%%%%%%%%%%%%%%%%
addDeltaDelta=0;
deltadeltas=[]

%%%%%
%SDC%
%%%%%

%Dont use delta or deltadelta or rmover power term with this option. However one can use mel +
%SDC. With this option N MFCC are added to the SDC. Remove power is done
%automatic with this option

N=7;  % number of cepstral coefficients in each cepstral vector
d=1;  % time advance and delay for the delta computation
P=3;  % timeshift netween consecutive blocks
k=7;  % number of blocks whose delta coefficients are concatenated to form the SDC vector

SDC_coeff=1;
SDC_c=[];


%variable to hold total coeff
totalCoeff=0;

%Vector of features
features=[];

%Iterate over language files
for i=1:5

    %Directory of training files. This is also the filename of the feature
    %files

    dname=('engn');

    tempX=0;

    if (i==2)
        dname='germ';
    end
    if(i==3)
        dname='japn';
    end
    
    if(i==4)
        dname='span'
    end
    
    

    
    % if(i==3)
    %     dname='othersounds2';
    % end


    %Path to training files
    dir2 = ['e:\CallFriend\train\' dname '\']

    %Read all names in dir
    a=dir(dir2);

    %Open file for writing
    fid = fopen([dname new '.dat'],'w','a');

    %index start at 3 to remove . and .. from file list
    for x=3:length(a);

        sprintf('%s %2.0f','Processing trainfile :',x-2)

        %filename of training files
        filename=[dir2 a(x).name];

        %read wave
        [signal,sr]=wavread(filename);

        %remove silence from first 5 minutes. will never use more
        if(remove_silence)
            'removing silence'
            signal=removesilence(signal(1:2400000), 20,10);
        end

        %All files are approx 30 minutes, some are shorter. Extract 80 seconds
        %data from each file. SR = 8000 for speech files
        if (length(signal)>(480000))
            signal=signal(1:(480000));
        end

        if(PLP==1 && ~(SDC_coeff)==1 && ~(mel==1))
            'plp not SDC'
            % Calculate orderth order PLP features with/without RASTA
            [coeff1, spec2] = rastaplp(signal, sr, rasta, order);
            totalCoeff=order+1;
            if(remove_power==1)
                'remover power'
                %Remove first coefficient
                coeff1(1,:)=[];
                %Update total
                totalCoeff=totalCoeff-1;
            end
            if(featureWarp)
                'feature warp'
                coeff1=feature_warp(windowLength,coeff1(:));
            end


            coeff1;
        end

        if(PLP==1 && (SDC_coeff)==1 && ~(mel==1))
            'plp and SDC'
            % Calculate orderth order PLP features with/without RASTA
            [coeff1, spec2] = rastaplp(signal, sr, rasta, order);
            totalCoeff=order+1;
            coeff1(1,:)=[];
            %make a copy of MFCCs
            coeff2=coeff1;
            %Update
            totalCoeff=totalCoeff-1;
            di=totalCoeff
            numCoeff=totalCoeff;
            totalCoeff=(totalCoeff*k);
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;
            
            if(featureWarp)
                'feature warp'
                coeff2=feature_warp(windowLength,coeff2(:));
            end


            coeff1;
        end

        if(mel==1 && ~(SDC_coeff)==1)
            'mel not SDC'
            %Extract numCoeff melfcc components with default settings
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            if(remove_power==1)
                'remover power'
                %Remove first coefficient
                coeff1(1,:)=[];
                %Update total
                totalCoeff=totalCoeff-1;


            end
           if(featureWarp)
                'feature warp'
                coeff1=feature_warp(windowLength,coeff1(:));
            end
        end




        if(SDC_coeff==1 && mel==1 && ~(PLP==1))
            'SDC and Mel'
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            coeff1(1,:)=[];
            %make a copy of MFCCs
            coeff2=coeff1;
            %Update
            totalCoeff=numCoeff-1;
            di=totalCoeff;
            totalCoeff=(totalCoeff*k);
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;
            
            if(featureWarp)
                'feature warp'
                coeff2=feature_warp(windowLength,coeff2(:));
            end
            %SDC_c(1:100)
        end

        if(SDC_coeff==1 && ~(mel==1) && ~(PLP==1))
            'SDC and not mel'
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            coeff1(1,:)=[];
            totalCoeff=numCoeff-1;
            totalCoeff=totalCoeff*k;
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;
            if(featureWarp)
                coeff1=feature_warp(windowLength,coeff1(:));
            end
            %SDC_c(1:100)
        end
 

    if(addDelta)==1
        deltas = delta(coeff1);
        if(featureWarp)
            deltas=feature_warp(windowLength,deltas(:));
        end
    end

    if(addDeltaDelta)==1
        deltadeltas=deltadelta(deltas);
        if(featureWarp)
            deltadeltas=feature_warp(windowLength,deltadeltas(:));
        end

    end

    %Size of signal
    [r,c]=size(coeff1);
    r*c;
    len=r*c;
    totalCoeff;

    %Check that MFCC length is legal, if not cut to right length.
    if (mod(len,totalCoeff)~=0)
        error=error+1;
        re=floor(len/totalCoeff);
        len=re*totalCoeff;
    end

    %Helper variable
    j=1;

    %Make feature file
    for i2=1:totalCoeff:len
        %Write flag
        writeFlag=1;

        if((PLP==1) && ~(SDC_coeff==1))
            %check and discard NaN feature lines
            if (any(isnan(coeff1(i2:i2+totalCoeff-1))) )
                writeFlag=-1;
            end
            features =[coeff1(i2:i2+totalCoeff-1)];
            %                if(i2>1)
            %                    pause(inf)
            %                end


        end
        if((PLP==1) && (SDC_coeff==1))
            %check and discard NaN feature lines
            if (any(isnan(coeff2(j:j+(numCoeff)-1))) || any(isnan(SDC_c(i2:i2+(totalCoeff)-1))))
                %Do not write to file
                writeFlag=-1;
            end
            features =[coeff2(j:j+(numCoeff)-1) SDC_c(i2:i2+(totalCoeff)-1) ];



        end


        if(mel && ~SDC_coeff)
            %check and discard NaN feature lines
            if (any(isnan(coeff1(i2:i2+totalCoeff-1))) )
                writeFlag=-1;
            end

            features =[coeff1(i2:i2+totalCoeff-1)];

            if(addDelta==1)
                features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1)];
                if (any(isnan(deltas(i2:i2+totalCoeff-1))))
                    writeFlag=-1;
                end
            end

            if(addDeltaDelta==1)
                features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1) deltadeltas(i2:i2+totalCoeff-1)];
                if (any(isnan(deltadeltas(i2:i2+totalCoeff-1))))
                    writeFlag=-1;
                end
            end
        end





        if(SDC_coeff==1 && mel==1)

            %check and discard NaN feature lines
            if (any(isnan(coeff2(j:j+(numCoeff-1)-1))) || any(isnan(SDC_c(i2:i2+(totalCoeff)-1))))
                %Do not write to file
                writeFlag=-1;
            end
            features =[coeff2(j:j+(numCoeff-1)-1) SDC_c(i2:i2+(totalCoeff)-1) ];

        end


        if(SDC_coeff==1 && ~(mel==1) && ~(PLP==1))
                features =[SDC_c(i2:i2+(totalCoeff)-1)];
        end
        

        j=j+di;

        %Write features to file
        if(writeFlag~=-1)
            fprintf(fid,'%f ',features,6);
            fprintf(fid,'\n');
        end
    end


end


end

fclose(fid);



