function [mix, options, errlog] = make_gmm()

%Make a GMM to describe the distribution given by feature files on disc
%usually named 'speech.dat' and 'music.dat' or names of language files :
%'engn.dat' or 'germ.dat'.
%The function saves the model to disc.
%
%Author Tommy Strmhaug,2008

%Number of times to iterate
for it=1:1

    if(it==1)
        %Load feature sets
        [feat, t, nin, nout, ndata] = datread('span.dat');

        category ='span_silence_removed_7_PLP_rasta_SDC7_1_3_7';
    else
        if(it==2)
            [feat, t, nin, nout, ndata] = datread('germ.dat');
            category ='germ_silence_removed_MFCC_8_Feature_warping_SDC7_1_3_7';

        else
            [feat, t, nin, nout, ndata] = datread('othersounds-7-5-sec.dat');
            category ='othersoundsdiagS7mfccDC7-1-3-7';
        end

    end

    size(feat)
    tic
    %feat=single(feat);
    %Now make GMM approximations to the data distribution using various numbers
    %of mixtures.If planning to make models with different number of mixtures
    %one can fill the number in in the array below.

    %Number of mixtures

    values=[96];

    for it=1:length(values)

        filenamemix = int2str(values(it))
        filename = [category filenamemix];

        ncentres = values(it)

        [inputdim,M] = size(feat);
        inputdim=M;

        %Number of EM-algorithm

        itr = 50;

        %NetLab GMM
        mix = gmm(inputdim, ncentres, 'diag');
        options = foptions;

        options(1) = 1; % Display error values.

        %minimum change in log-likelihood
        %options(3) = .1;

        % Maximum number of iterations for K-means algorithm.
        options(14) = 50;
        disp('Initializing GMM with k-means');
        mix = gmminit(mix, feat, options);
        % Display error values.
        options(1) = 1;
        % Prevent Covar values from collapsing
        %options(5) = 1;

        % Max. number of iterations
        options(14) = itr;
        disp('Running EM for mixture model');
        [mix, options, errlog] = gmmem(mix, feat, options);

        %Save model
        save (filename, 'mix');
        x = [5.4 3.6] ;
        %prob = gmmprob(mix, x)
        %mix.nin
        toc
    end
end