function E4 = modulation_energy(x,fs);
% Function to compute modulation spectrogram for signal 'x' sampled at 'fs' Hz.
% Add more parameters to specify the exact modulation transform
% Author Tommy Strmhau,2008

[B,F,M] = modspecgram(x,fs);

% Sum modulation energy across the (acoustic) frequency dimension
E = sum(abs(B));

% Sum the energy around the 4 Hz modulation frequency range
E4 = sum(E(M>3 & M<5));
