function E = short_time_energy(signal, windowLength,step);

%function to calculate short time energy

%Author Tommy Strmhaug, 2008

signal = signal / max(max(signal));
currentPos = 1;
l = length(signal);
numOfFrames = floor((l-windowlength)/step) + 1;
E = zeros(numOfFrames,1);
for (i=1:numOfFrames)
    window = (signal(currentPos:currentPos+windowlength-1));
    E(i) = (1/(windowlength)) * sum(abs(window.^2));
    currentPos = currentPos + step;
end
