function c = spectral_centroid(signal,windowLength, step, fs)

%Function to calculate the spectral centroid
%Author Tommy Strmhaug, 2008

signal = signal / max(abs(signal));
l = length(signal);
numOfFrames = floor((l-windowlength)/step) + 1;
H = hamming(windowlength);
currentPos = 1;
m = ((fs/(2*windowlength))*[1:windowlength])';
c = zeros(numOfFrames,1);
for (i=1:numOfFrames)
    window = H.*(signal(currentPos:currentPos+windowlength-1));
    FFT = (abs(fft(window,2*windowlength)));
    FFT = FFT(1:windowlength);
    FFT = FFT / max(FFT);
    c(i) = sum(m.*FFT)/sum(FFT);
    if (sum(window.^2)<0.010)
        c(i) = 0.0;
    end
    currentPos = currentPos + step;
end
c = c / (fs/2);