function F = spectral_flux(signal,windowLength, step, fs)

%Function to calculate the spectral flux
%Author Tommy Strmhaug, 2008

signal = signal / max(abs(signal));
currentPos = 1;
l = length(signal);
numOfFrames = floor((l-windowlength)/step) + 1;
H = hamming(windowlength);
m = [0:windowlength-1]';
F = zeros(numOfFrames,1);
for (i=1:numOfFrames)
    window = H.*(signal(currentPos:currentPos+windowlength-1));    
    FFT = (abs(fft(window,2*windowlength)));
    FFT = FFT(1:windowlength);        
    FFT = FFT / max(FFT);
    if (i>1)
        F(i) = sum((FFT-FFTprev).^2);
    else
        F(i) = 0;
    end
    currentPos = currentPos + step;
    FFTprev = FFT;
end