function sR = spectral_rollOff(signal,windowlength, step, c, fs)

%function to calculate spectral rolloff
%the parameter c is given in percent.Spectral Rolloff is the frequency below which c=85 percent of spectrum
%distribution concentrated. 

%Author Tommy Strmhaug, 2008

signal = signal / max(abs(signal));
currentPos = 1;
l = length(signal);
numOfFrames = (l-windowlength)/step + 1;
H = hamming(windowlength);
m = [0:windowlength-1]';
for (i=1:numOfFrames)
    window = (signal(currentPos:currentPos+windowlength-1));    
    FFT = (abs(fft(window,512)));
    FFT = FFT(1:255);
    totalEnergy = sum(FFT);
    curEnergy = 0.0;
    countFFT = 1;
    while ((curEnergy<=c*totalEnergy) && (countFFT<=255))
        curEnergy = curEnergy + FFT(countFFT);
        countFFT = countFFT + 1;
    end
    sR(i) = ((countFFT-1))/(fs/2);
    currentPos = currentPos + step;
end