function [mu sp]= test_gmm();

%function to test for speech/music and other

%Author Tommy Strmhaug, 2008

%Parameters are marked with boxes of %

features=[];

%decision length in duration*10 milliseconds
duration = 300

%variables related to error computation
totalError=0;
speechError=0;
musicError=0;
otherError=0;

total1=0;
total2=0;
total3=0;

errorInstancesM=0;
errorInstancesS=0;
errorInstancesO=0;

mu=[];
sp=[];

%iterate through all categories
for i=1:3

    %location of train files
    dname=('speech');
    if (i==2)
        dname='music\concatenated';
    end

    if(i==3)
        dname='D:\matlab\othersounds2\BBC test\'

    end

    globalSpeech=0;
    globalMusic=0;
    globalOther=0;


    %%%%%%%%%%%%
    %use melfcc%
    %%%%%%%%%%%%
    mel=1;
    %number of coeff in model.
    numCoeff=8;

    %%%%%%%%%%%%%%%%%%%
    %remove power term%
    %%%%%%%%%%%%%%%%%%%
    remove_power=1;

    %%%%%%%
    %delta%
    %%%%%%%
    addDelta=0;
    deltas=[];

    %%%%%%%%%%%%
    %deltadelta%
    %%%%%%%%%%%%
    addDeltaDelta=0;
    deltadeltas=[];

    %%%%%
    %SDC%
    %%%%%
    %Dont use delta or deltadelta or remover power term with this option. However one can use mel +
    %SDC. With this option N Melfcc are added to the SDC. remove power is done
    %automatic
    N=7;  % number of cepstral coefficients in each cepstral vector
    d=1;  % time advance and delay for the delta computation
    P=3;  % timeshift netween consecutive blocks
    k=7;  % number of blocks whose delta coefficients are concatenated to form the SDC vector
    %use SDC
    SDC_coeff=1;
    SDC_c=[];

    totalCoeff=0;

    dir2 = ['d:\matlab\musicspeech\wavfile\test\' dname '\'];   %dname '\'
    if(i==3)
        dir2=dname;
    end

    %read all names in dir
    a=dir(dir2)

    %load models
    load speechdiag7mfccSDC7-1-3-764.mat
    speech_model = mix;
    mix
    load musicdiag7mfccSDC7-1-3-764.mat
    music_model = mix;
    mix
    load othersoundsdiag7mfccSDC7-1-3-7_7-5s_64-finished.mat
    other_model=mix

    speech=1;
    music=1;
    other=1;
    s=0;
    m=0;

    %fid = fopen(['testspeech.dat'],'w','a');
    %index start at 3 to remover . and .. from file list
    for x=3:(length(a));
        sprintf('%s %2.0f :%s ','Processing testfile :',x-2,dname)

        filename=[dir2 a(x).name]
        %Load file
        [signal,sr]=wavread(filename);
        signal;
        %How much signa to use
        if (length(signal)>(100000))
            signal=signal(1:(100000));
        end

        if(mel==1)
            %Extract numCoeff melfcc components with default settings
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
        end

        if(remove_power==1)
            %remove first coeffient
            coeff1(1,:)=[];
            totalCoeff=numCoeff-1;
        else
            totalCoeff=numCoeff;
        end

        if(addDelta)==1
            deltas = delta(coeff1);
        end

        if(addDeltaDelta)==1
            deltadeltas=deltadelta(deltas);
        end


        if(SDC_coeff==1 && mel==1)
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            coeff1(1,:)=[];
            %make a copy of MFCCs
            coeff2=coeff1;
            totalCoeff=numCoeff-1;
            totalCoeff=(totalCoeff*k);
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;
        else

            if(SDC_coeff==1 && ~(mel==1))
                coeff1=melfcc(signal,sr,'numcep', numCoeff);
                coeff1(1,:)=[];
                totalCoeff=numCoeff-1;
                totalCoeff=totalCoeff*k;
                %SDC must have a vector
                SDC_c=SDC(coeff1,N,d,P,k);
                coeff1=SDC_c;
                %SDC_c(1:100)
            end
        end


        %Number of of mfccs
        coeff1=coeff1(:);
        coeff1=coeff1';

        length(coeff1)/numCoeff;
        range=1;
        j=1;
        for i2=1:totalCoeff:(length(coeff1))

            %     tempspeech = (gmmprob(speech_model,coeff1(i2:i2+12)));
            %     tempmusic = (gmmprob (music_model,coeff1(i2:i2+12)));
            if(mel==1)
                features =[coeff1(i2:i2+totalCoeff-1)];
            end

            if(addDelta==1)
                features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1)];
            end

            if(addDeltaDelta==1)
                features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1) deltadeltas(i2:i2+totalCoeff-1)];
            end

            if(SDC_coeff==1 && mel==1)


                features =[coeff2(j:j+(numCoeff-1)-1) SDC_c(i2:i2+(totalCoeff)-1) ];

            else
                if(SDC_coeff==1 && ~(mel==1))

                    features =[SDC_c(i2:i2+(totalCoeff)-1)];
                end
            end

            j=j+7;
            %Probability density values
            tempspeech = -log10(gmmprob(speech_model,features));

            t=gmmprob(speech_model,features);

            tempmusic = -log10(gmmprob (music_model,features));

            t2=gmmprob (music_model,features);

            tempother = -log10(gmmprob (other_model,features));

            speech=speech+(tempspeech);

            music=music+(tempmusic);

            other=other+(tempother);

            if range==duration

                %because a smal value have a higher log value less is
                %better

                if (speech<music)
                    if(speech<other)
                        globalSpeech=globalSpeech+1;
                        'speech'
                    else
                        globalOther=globalOther+1;
                        'other'
                    end
                else
                    if (music<other)
                        globalMusic=globalMusic+1;
                        'music'
                    else
                        globalOther=globalOther+1;
                        'other'
                    end
                end


                sp(end+1)=(speech);
                mu(end+1)=(music);
                speech;

                music;
                speech=1;
                music=1;
                other=1;

                range=0;
            end

            range=range+1;

        end

    end

    if(strcmp(dname, 'speech'))==1
        speechError = ((globalMusic+globalOther)/(globalSpeech+globalMusic+globalOther))*100
        errorInstancesM =errorInstancesM+globalMusic;
        errorInstancesO =errorInstancesO+globalOther;
        total1=globalMusic+globalSpeech+globalOther;
    end

    if(strcmp(dname, 'music\concatenated'))==1
        musicError = ((globalSpeech+globalOther)/(globalSpeech+globalMusic+globalOther))*100
        errorInstancesS =errorInstancesS+globalSpeech;
        errorInstancesO =errorInstancesO+globalOther;
        total2=globalMusic+globalSpeech+globalOther;
    end

    if(strcmp(dname, 'D:\matlab\othersounds2\BBC test\'))==1
        otherError = ((globalSpeech+globalMusic)/(globalSpeech+globalMusic+globalOther))*100
        errorInstancesS =errorInstancesS+globalSpeech;
        errorInstancesM =errorInstancesM+globalMusic;
        total3=globalOther+globalSpeech+globalMusic;
    end

end

globalSpeech
globalMusic

%Error report

speechError
musicError
otherError

totalError = (errorInstancesM+errorInstancesS+errorInstancesO)/(total1+total2+total3)*100



