function [mu sp]= test_gmm();

%Function to test language identification models.
%This file is kind of messy because there are little internal control, so
%it is possible to run illegal combinations of parameters. Each parameter
%has a comment of the most important restrictions. An example is that one
%should not run PLP and MFCC at the same time. One also have to make sure
%that the parameters are equal for this function and the test function.

%Parameter adjusting are marked with boxes of %s, 1 means true, 0 false
features=[];
%delta function

di=0;
%%%%%%%%%%%%%%%%%
%Decision length%
%%%%%%%%%%%%%%%%%
%decision length in duration*10 milliseconds
duration = 500

%language ident
%use engn,span,japn,germ,fraq for English,Spanish, Japanese, Deutsch and
%France
language1='engn';
language2='germ';
language3='span';
language4='japn';
language5='fraq';
%total number of languages
numberOfLanguages=5;

%variables related to error computation. Error1 = first language, Error2 =
%second ...
totalError=0;
Error1=0;
Error2=0;
Error3=0;
Error4=0;
Error5=0;

total1=0;
total2=0;
total3=0;
total4=0;
total5=0;

errorInstances2=0;
errorInstances1=0;
errorInstances3=0;
errorInstances4=0;
errorInstances5=0;

mu=[];
sp=[];

%confusion matrix variables
l11=0;
l12=0;
l13=0;
l14=0;
l15=0;

l21=0;
l22=0;
l23=0;
l24=0;
l25=0;

l31=0;
l32=0;
l33=0;
l34=0;
l35=0;

l41=0;
l42=0;
l43=0;
l44=0;
l45=0;

l51=0;
l52=0;
l53=0;
l54=0;
l55=0;




%Iterate through test dirs
for i=1:numberOfLanguages

    dname=language1;



    if(i==2)
        dname=language2;
    end



    if (i==3)
        dname=language3;
    end
    if (i==4)
        dname=language4;
    end
    if (i==5)
        dname=language5;
    end

    global1=0;
    global2=0;
    global3=0;
    global4=0;
    global5=0;

    %%%%%%%%%%%
    %PLP-Rasta%
    %%%%%%%%%%%
    %Do not use this together with MFCC. Do not use remove power either.
    %When using PLP together with SDC ->order*k is the number of concatenated
    %deltas to form the SDC.

    PLP=1;
    %Rasta filtering
    rasta=1;
    %model order. Remember that order+1 is number of coefficients
    order=7;

    %%%%%%
    %MFCC%
    %%%%%%
    mel=0;
    %Number of MFCC coeffs to extract. This is the number before removing the
    %power term. Do not use together with PLP
    numCoeff=8;

    %%%%%%%%%%%%
    %Remove power term%
    %%%%%%%%%%%%
    remove_power=0;

    %%%%%%%%%%%%%%%%%
    %Feature Warping%
    %%%%%%%%%%%%%%%%%%
    featureWarp=0;
    %time in seconds for feature warp window
    time=3;
    %Window length in number of features(default step time for MFCC and PLP is 10 ms)
    if(mel==1)
        windowLength=numCoeff*time*100+1;
    end

    if(PLP==1)
        windowLength=(order+1)*time*100+1;
    end

    %%%%%%%%%%%%%%%%%%%%
    %Delta Coefficients%
    %%%%%%%%%%%%%%%%%%%%
    addDelta=0;
    deltas=[];

    %%%%%%%%%%%%%%%%%%%%%%%%%%
    %Delta delta Coefficients%
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    addDeltaDelta=0;
    deltadeltas=[];

    %%%%%%%%%%%%%%%%
    %Remove Silence%
    %%%%%%%%%%%%%%%%
    remove_silence=1;

    %%%%%
    %SDC%
    %%%%%
    %Dont use delta or deltadelta or remover power term with this option. However one can use mel +
    %SDC. With this option N Melfcc are added to the SDC. remove power is done
    %automatic
    N=7;  % number of cepstral coefficients in each cepstral vector
    d=1;  % time advance and delay for the delta computation
    P=3;  % timeshift netween consecutive blocks
    k=7;  % number of blocks whose delta coefficients are concatenated to form the SDC vector

    SDC_coeff=1;
    SDC_c=[];

    %Total number of coefficients
    totalCoeff=0;

    %Dir for test files
    dir2 = ['D:\CallFriend\test\' dname '\'];   %dname '\'

    %Read all names in dir
    a=dir(dir2);

    %Load models
    load engn_silence_removed_7_PLP_rasta_SDC7_1_3_7_64.mat
    model1 = mix;

    load germ_silence_removed_7_PLP_rasta_SDC7_1_3_7_64.mat
    model2 = mix;

    load span_silence_removed_7_PLP_rasta_SDC7_1_3_7_64.mat
    model3 = mix;

    load japn_silence_removed_7_PLP_rasta_SDC7_1_3_7_64.mat
    model4 = mix;

    load fraq_silence_removed_7_PLP_rasta_SDC7_1_3_7_64.mat
    model5 = mix;

    lang2=0;
    lang1=0;
    lang3=0;
    lang4=0;
    lang5=0;


    %index start at 3 to remover . and .. from file list
    for x=3:length(a);
        sprintf('%s %2.0f :%s ','Processing testfile :',x-2,dname)
        %Read filenames
        filename=[dir2 a(x).name];

        [signal,sr]=wavread(filename);

        %Remove silence from first 4 minutes. will never use more
        if(remove_silence)
            signal=removesilence(signal(1:1920000), 20,10);
            'removing silence'
        end

        %All files are approx 30 minutes, some are shorter. Extract x seconds
        %data from each test file. SR = 8000 for speech files
        if (length(signal)>(280000))
            %make 4 desicions per test file, and dont start at the
            %beginning
            signal=signal(50000:(124000));
        end

        if(PLP==1 && ~(SDC_coeff)==1 && ~(mel==1))
            'plp not SDC'
            % Calculate orderth order PLP features with/without RASTA
            [coeff1, spec2] = rastaplp(signal, sr, rasta, order);
            totalCoeff=order+1;
            coeff1;

            if(remove_power==1)
                'remover power'
                %Remove first coefficient
                coeff1(1,:)=[];
                %Update total
                totalCoeff=totalCoeff-1;
            end
            if(featureWarp)
                'feature warp'
                coeff1=feature_warp(windowLength,coeff1(:));
            end
        end
        if(PLP==1 && (SDC_coeff)==1 && ~(mel==1))
            'plp and SDC'
            % Calculate orderth order PLP features with/without RASTA
            [coeff1, spec2] = rastaplp(signal, sr, rasta, order);
            totalCoeff=order+1;
            coeff1(1,:)=[];
            %make a copy of MFCCs
            coeff2=coeff1;
            %Update
            totalCoeff=totalCoeff-1;
            di=totalCoeff
            numCoeff=totalCoeff;
            totalCoeff=(totalCoeff*k);
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;

            if(featureWarp)
                'feature warp'
                coeff2=feature_warp(windowLength,coeff2(:));
            end


            coeff1;
        end


        if(mel==1 && ~(SDC_coeff)==1)
            'mel not SDC'
            %Extract numCoeff melfcc components with default settings
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            if(remove_power==1)
                'remover power'
                %Remove first coefficient
                coeff1(1,:)=[];
                %Update total
                totalCoeff=totalCoeff-1;


            end
            if(featureWarp)
                'feature warp'
                coeff1=feature_warp(windowLength,coeff1(:));
            end
        end


        if(addDelta)==1
            deltas = delta(coeff1);
            if(featureWarp)
                deltas=feature_warp(windowLength,deltas(:));
            end
        end

        if(addDeltaDelta)==1
            deltadeltas=deltadelta(deltas);
            if(featureWarp)
                deltadeltas=feature_warp(windowLength,deltadeltas(:));
            end
        end

        if(SDC_coeff==1 && mel==1 && ~(PLP==1))
            'SDC and Mel'
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            coeff1(1,:)=[];
            %make a copy of MFCCs
            coeff2=coeff1;
            %Update
            totalCoeff=numCoeff-1;
            di=totalCoeff;
            totalCoeff=(totalCoeff*k);
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;

            if(featureWarp)

                coeff2=feature_warp(windowLength,coeff2(:));
            end
            %SDC_c(1:100)
        end

        if(SDC_coeff==1 && ~(mel==1) && ~(PLP==1))
            'SDC and not mel'
            coeff1=melfcc(signal,sr,'numcep', numCoeff);
            coeff1(1,:)=[];
            totalCoeff=numCoeff-1;
            totalCoeff=totalCoeff*k;
            SDC_c=SDC(coeff1,N,d,P,k);
            %to get correct length
            coeff1=SDC_c;
            if(featureWarp)
                coeff1=feature_warp(windowLength,coeff1(:));
            end
            %SDC_c(1:100)
        end


        coeff1=coeff1(:);
        coeff1=coeff1';

        length(coeff1)/numCoeff;
        'length'
        length(coeff1)
        totalCoeff
        range=1;
        j=1;

        for i2=1:totalCoeff:(length(coeff1))

            %     tempspeech = (gmmprob(speech_model,coeff1(i2:i2+12)));
            %     tempmusic = (gmmprob (music_model,coeff1(i2:i2+12)));

            if(PLP==1 && ~(SDC_coeff==1))
                features =[coeff1(i2:i2+totalCoeff-1)];
                %                 if(i2>1)
                %                     pause(inf)
                %                 end

            end

            if((PLP==1) && (SDC_coeff==1))
                %check and discard NaN feature lines


                features =[coeff2(j:j+(numCoeff)-1) SDC_c(i2:i2+(totalCoeff)-1) ];

            end


            if(mel && ~SDC_coeff)
                %check and discard NaN feature lines

                features =[coeff1(i2:i2+totalCoeff-1)];

                if(addDelta==1)
                    features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1)];

                end

                if(addDeltaDelta==1)
                    features =[coeff1(i2:i2+totalCoeff-1) deltas(i2:i2+totalCoeff-1) deltadeltas(i2:i2+totalCoeff-1)];

                end
            end

            if(SDC_coeff==1 && mel==1)


                features =[coeff2(j:j+(numCoeff-1)-1) SDC_c(i2:i2+(totalCoeff)-1) ];

            end


            if(SDC_coeff==1 && ~(mel==1) && ~(PLP==1))
                features =[SDC_c(i2:i2+(totalCoeff)-1)];
            end


            j=j+di;

            %Probability dinsities

            temp1 = -log10(gmmprob(model1,features));

            %t=gmmprob(engn_model,features);

            temp2 = -log10(gmmprob (model2,features));

            %t2=gmmprob (germ_model,features);

            temp3 = -log10(gmmprob(model3,features));

            temp4 = -log10(gmmprob(model4,features));

            temp5 = -log10(gmmprob(model5,features));

            lang1=lang1+(temp1);

            lang2=lang2+(temp2);

            lang3=lang3+temp3;

            lang4=lang4+(temp4);

            lang5=lang5+temp5;

            if range==duration

                %because a smaller value have a higher log value
                %
                %                 if (lang1<lang2)
                %                     if(lang1<lang3)
                %
                %                     else
                %
                %
                %                         global3=global3+1;
                %                         language3
                %                     end
                %
                %
                %                 else
                %                     if (lang2<lang3)
                %                         global2=global2+1;
                %                         language2
                %                     else
                %                         global3=global3+1;
                %                         language3
                %                     end
                %                 end

                candidate = min(lang1,lang2);
                candidate2 =min(lang3,lang4);
                candidate3 =min(candidate,candidate2);
                candidate4= min(candidate3,lang5);

                if candidate4 == lang1
                    global1=global1+1;
                    language1
                end

                if candidate4 == lang2
                    global2=global2+1;
                    language2
                end

                if candidate4 == lang3
                    global3=global3+1;
                    language3
                end

                if candidate4 == lang4
                    global4=global4+1;
                    language4
                end

                if candidate4 == lang5
                    global5=global5+1;
                    language5
                end

                lang1=0;
                lang2=0;
                lang3=0;
                lang4=0;
                lang5=0;


                range=0;
            end

            range=range+1;

        end

    end

    if(strcmp(dname, language1))==1
        Error1 = ((global2+global3+global4+global5)/(global1+global2+global3+global4+global5))*100
        errorInstances2 =errorInstances2+global2;
        errorInstances3 =errorInstances3+global3;
        errorInstances4 =errorInstances4+global4;
        errorInstances5 =errorInstances5+global5;
        total1=global2+global1+global3+global4+global5;
        l11=total1-(global2+global3+global4+global5);
        l12=global2;
        l13=global3;
        l14=global4;
        l15=global5;

    end
    if(strcmp(dname, language2))==1
        Error2 = ((global1+global3+global4+global5)/(global1+global2+global3+global4+global5))*100
        errorInstances1=errorInstances1+global1;
        errorInstances3=errorInstances3+global3;
        errorInstances4=errorInstances4+global4;
        errorInstances5=errorInstances5+global5;

        total2=global2+global1+global3+global4+global5;

        l22=total2-(global1+global3+global4+global5);
        l21=global1;
        l23=global3;
        l34=global4;
        l35=global5;
    end

    if(strcmp(dname, language3))==1
        Error3 = ((global1+global2+global4+global5)/(global1+global2+global3+global4+global5))*100
        errorInstances1=errorInstances1+global1;
        errorInstances2=errorInstances2+global2;
        errorInstances4=errorInstances4+global4;
        errorInstances5=errorInstances5+global5;
        total3=global2+global1+global3+global4+global5;
        l33=total3-(global2+global1+global4+global5);
        l32=global2;
        l31=global1;
        l34=global4;
        l35=global5;

    end

    if(strcmp(dname, language4))==1
        Error4 = ((global1+global2+global3+global5)/(global1+global2+global3+global4+global5))*100
        errorInstances1=errorInstances1+global1;
        errorInstances2=errorInstances2+global2;
        errorInstances3=errorInstances3+global3;
        errorInstances5=errorInstances5+global5;
        total4=global2+global1+global3+global4+global5;
        l44=total4-(global2+global1+global3+global5);
        l41=global1;
        l42=global2;
        l43=global3;
        l45=global5;

    end

    if(strcmp(dname, language5))==1
        Error5 = ((global1+global2+global3+global4)/(global1+global2+global3+global4+global5))*100
        errorInstances1=errorInstances1+global1;
        errorInstances2=errorInstances2+global2;
        errorInstances3=errorInstances3+global3;
        errorInstances4=errorInstances4+global4;
        total5=global2+global1+global3+global4+global5;
        l55=total5-(global2+global1+global3+global4);
        l51=global1;
        l52=global2;
        l53=global3;
        l54=global4;
    end

    global1
    global2
    global3

end

%Error report
sprintf('%s %s :%f',language1,'error :',Error1)
sprintf('%s %s :%f',language2,'error :',Error2)
sprintf('%s %s :%f',language3,'error :',Error3)
sprintf('%s %s :%f',language4,'error :',Error4)
sprintf('%s %s :%f',language5,'error :',Error5)

totalError = (errorInstances2+errorInstances1+errorInstances3+errorInstances4+errorInstances5)/(total1+total2+total3+total4+total5)*100
%confusion
sprintf('%f %f %f %f %f',l11,l12,l13,l14,l15)
sprintf('%f %f %f %f %f',l21,l22,l23,l24,l25)
sprintf('%f %f %f %f %f',l31,l32,l33,l34,l35)
sprintf('%f %f %f %f %f',l41,l42,l43,l44,l45)
sprintf('%f %f %f %f %f',l51,l52,l53,l54,l55)




